## immer 1.2-19

=== DESCRIPTION ===
Package: immer
Type: Package
Title: Item Response Models for Multiple Ratings
Version: 1.2-19
Date: 2022-04-11 12:19:15
Author: 
    Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
Description: 
    Implements some item response models for multiple
    ratings, including the hierarchical rater model, 
    conditional maximum likelihood estimation of linear 
    logistic partial credit model and a wrapper function
    to the commercial FACETS program. See Robitzsch and
    Steinfeld (2018) for a description of the functionality
    of the package. 
    See Wang, Su and Qiu (2014; <doi:10.1111/jedm.12045>)
    for an overview of modeling alternatives.
Depends: R (>= 3.0-0)
Imports: CDM, coda, graphics, methods, psychotools, Rcpp, sirt, stats,
        TAM
Suggests: MASS
Enhances: eRm, lme4
LinkingTo: Rcpp, RcppArmadillo
URL: https://github.com/alexanderrobitzsch/immer,
        https://sites.google.com/site/alexanderrobitzsch2/software
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2022-04-11 10:21:12 UTC; sunpn563
Repository: CRAN
Date/Publication: 2022-04-13 07:52:34 UTC
