## immer 1.3-3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 1.2-19
-Date: 2022-04-11 12:19:15
+Version: 1.3-3
+Date: 2022-05-17 12:00:59
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
@@ -26,6 +26,6 @@
         https://sites.google.com/site/alexanderrobitzsch2/software
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2022-04-11 10:21:12 UTC; sunpn563
+Packaged: 2022-05-17 10:03:29 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2022-04-13 07:52:34 UTC
+Date/Publication: 2022-05-17 14:00:08 UTC
