## immer 1.5-13

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 1.4-15
-Date: 2022-08-22 12:17:33
+Version: 1.5-13
+Date: 2024-03-21 15:57:11
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
@@ -26,6 +26,6 @@
         https://sites.google.com/site/alexanderrobitzsch2/software
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2022-08-22 10:19:53 UTC; sunpn563
+Packaged: 2024-03-21 14:59:23 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2022-08-22 10:50:02 UTC
+Date/Publication: 2024-03-21 15:20:02 UTC
